/*
 *
 * Modification History:
 *
 * January 19, 1993 by Robin Miller, MILLER W J & ASSOCIATES
 *	o  Added missing return(0) at end of qnx_create_path_to().
 *	   This caused valid filenames to be reported as an error.
 */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#define SKIP_TO_SLASH(p)	{for(;*p && *p!='/';p++);}

/*
	qnx_create_path_to(filename)

	Will create directories in the path as neccessary to make it possible to
	subsequently create <filename>.

	This call does not guarantee that the file could actually be
	written - just that the path does exist. (i.e. no checking of
	permissions is done 

	returns 0 on success. Returns -1 on failure.
*/
int
qnx_create_path_to( char *fullpath ) {
	char *ptr = fullpath;

	if (fullpath[0] == '/' && fullpath[1] == '/')
	{
		/* starts with '//' */
		ptr += 2;
		SKIP_TO_SLASH(ptr);
		if (!*ptr || !*(ptr+1)) return(0);  /* zzx should check that path exists */
		ptr++;
		SKIP_TO_SLASH(ptr);
		if (!*ptr || !*(ptr+1)) return(0);
		ptr++;
	} else if (fullpath[0] == '/') ptr++;

	SKIP_TO_SLASH(ptr);
	
	for (;*ptr;)
	{
		*ptr = (char)0x00;
		if (mkdir(fullpath,S_IRWXU)==-1)
		{
			if (errno!=EEXIST)
			{
				perror(fullpath);
				*ptr = '/';
				return(-1);
			}
		}
		*ptr = '/';
		ptr++;
		SKIP_TO_SLASH(ptr);
	}
	return (0);
}
