/*
 *
 * Modification History:
 *
 * January 11, 1993 by Robin Miller, MILLER W J & ASSOCIATES
 *	Made porting changes for DEC OSF/1 Operating System.
 */
/*				27-Sep-89  8:08:40am										*/

/*--------------------------------------------------------------------------*/
/*  History: main.h, V0.0, ??-Nov-86 11:36:31am, Dan Dodge,	Baseline		*/
/*  				 V0.1, 13-Jan-87 11:36:31am, Dan Hildebrand				*/
/*----------------------------------------------------------------------------

	Symbols defined for Qterm file transfer protocols.

----------------------------------------------------------------------------*/
#ifndef TRUE
#define	TRUE		1
#define	FALSE		0
#endif

/*
 * Define some Architecture dependent types:
 */
#if defined(__alpha)

typedef unsigned long		ptr_t;
typedef int			int32_t;
typedef unsigned int		uint32_t;
typedef unsigned int		bool;

#else /* !defined(__alpha) */

typedef unsigned int		ptr_t;
typedef long			int32_t;
typedef unsigned long		uint32_t;
typedef unsigned char		bool;

#if !defined(_OSF_SOURCE)

typedef unsigned char		uchar_t;
typedef unsigned int		uint_t;
typedef unsigned short		ushort_t;

#endif /* !defined(_OSF_SOURCE) */

#if defined(ultrix)

#define const

typedef int			ssize_t;

#endif /* defined(ultrix) */

#endif /* defined(__alpha) */

#if !defined(_QNX_SOURCE)
/*
 * Macros for fast min/max.
 */
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

#define min	MIN
#define max	MAX

#endif /* !defined(_QNX_SOURCE) */

#define ONESEC		10		/* Value for 1 second with modem r/w routines	*/
#define	RETRY_MAX	10		/* Maximum number of retries					*/
#define MAXSIZE		2048	/* Maximum sub packet size						*/
#define	uchar		unsigned char

#define SOH			0x01
#define	STX			0x02
#define ETX			0x03
#define EOT			0x04
#define ENQ			0x05
#define ACK			0x06
#define	BELL		0x07
#define	BS			0x08
#define	TAB			0x09
#define	LF			0x0a
#define	VTAB		0x0b
#define	FF			0x0c
/*	#define	CR			0x0d	*/
#define	SO			0x0e
#define	SI			0x0f
#define	DLE			0x10
#define	DC1			0x11
#define	DC2			0x12
#define	DC3			0x13
#define	DC4			0x14
#define NAK			0x15
#define SYN			0x16
#define	ETB			0x17
#define CAN			0x18
#define EM			0x19
#define SUB			0x1a
#define ESC			0x1b
#define FS			0x1c
#define GS			0x1d
#define RS			0x1e
#define US			0x1f
#define	SP			0x20
#define DEL			0x7f

#define TEN_YEARS		315532800L 	/* 1990 Jan 1st - 1980 Jan 1st			*/

EXT FILE *logfp;
EXT int mdm;
EXT int debug_flag;
EXT char *debug_buffer;

EXT long fbytes;			/* Number of bytes in the file					*/
EXT char prefix[100];		/* Path name prefix to force onto files			*/
EXT char logfile[100];		/* Path name for activity log file (if any)		*/
EXT char has_timeouts;		/* True if OS supports timeouts on fget			*/
EXT char use_stdin;			/* True if protocol is sending over stdin		*/
EXT unsigned onesec;		/* Central time constant, usually = 1 sec		*/
EXT unsigned retry_limit;	/* Max number of retries, usually RETRY_MAX		*/
EXT time_t start_time, stop_time;	/* File tx start and stop times	*/
EXT	struct stat statbuf;	/* General purpose STAT entry buffer 			*/

/*---- Command line settable flags -----------*/
EXT char force;				/* Forced filename								*/
EXT char make_dir;			/* Allow rx routine to make sub-directories		*/
EXT char newer;				/* Receive only files newer than existing file	*/
EXT char qterm;				/* Set if Qterm invoked QCP						*/
EXT char relaxed;			/* Allows relaxed timing						*/
EXT char sending;			/* Set if txing or rxing						*/
EXT char today;				/* Set if today's date to be placed on file		*/
EXT char verbose;			/* Set to display error messages				*/
EXT char quiet;				/* Set to supress all output					*/
EXT char unlink_file;		/* Force unlink of unwriteable files			*/
EXT int batch;				/* Batch on/off flag -RM						*/
EXT int sub_packet_size;	/* Sub packet size * 8 = actual packet size		*/

/*-- Manifests and structs from QNX 2.15 ----*/

#define	NCPFN	16
#define _DIRECTORY		0x20

#pragma pack(1)

/*
 * Some of these fields are too small for POSIX, but are necessary for 2.15 compatibility.
 */
#if defined(ultrix)
	/*
	 * The ULTRIX compiler doesn't understand #pragma pack(1), so it
	 * changes the data alignment of fields in this structure (adds bytes).
	 * (Sorry, I couldn't figure out an easier way to defeat the compiler).
	 */
struct old_dir_entry {
	char fstat;
	unsigned char ffirst_xtnt[4];
	unsigned char flast_xtnt[4];
	unsigned char fnum_blks[4];
	unsigned char fnum_xtnt[2];
	unsigned char fowner;
	unsigned char fgroup;
	unsigned char fnum_chars_free[2];
	unsigned char fseconds[4];
	unsigned char ftype;
	unsigned char fgperms;
	unsigned char fperms;
	unsigned char fattr;
	unsigned char fdate[4];
	char fname[NCPFN + 1];
};
#else /* !defined(ultrix) */
struct old_dir_entry {
	char fstat;
	uint32_t ffirst_xtnt;
	uint32_t flast_xtnt;
	uint32_t fnum_blks;		/* unsigned to prevent sign extend */
	unsigned short fnum_xtnt;
	unsigned char fowner;		/* should be uid_t <-- too small */
	unsigned char fgroup;		/* should be gid_t <-- too small */
	unsigned short fnum_chars_free; /* No. unused chars in last block */
	time_t fseconds;
	unsigned char ftype;
	unsigned char fgperms;
	unsigned char fperms;
	unsigned char fattr;
	unsigned short fdate[2];
	char fname[NCPFN + 1];
	};
#endif /* defined(ultrix) */

#include "crc.h"
#include "main.def"
#include "cr_path.def"
#include "qcp_snd.def"
#include "qcp_rcv.def"
#include "dateconv.def"
